%if 0%{?fedora} > 12
%global with_python3 1
%else
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib())")}
%{!?python2_version: %global python2_version %(%{__python2} -c "from sys import stdout, version; stdout.write(version[:3])")}
%endif

%global commit c91d37c85d0a1cd9b3b3103b7758083f5e64dff2

Name:           python-ros_buildfarm
Version:        0.1.2
Release:        4%{?dist}
Summary:        Build farm used to build the ROS ecosystem's packages

Group:          Applications/System
License:        ASL 2.0
URL:            https://github.com/ros-infrastructure/ros_buildfarm
Source0:        https://github.com/ros-infrastructure/ros_buildfarm/archive/%{commit}/ros_buildfarm-%{commit}.tar.gz
Patch0:         %{name}-0.1.2-fix-post_url.patch

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
Requires:       python-catkin_pkg >= 0.2.6
Requires:       python-empy
Requires:       python-jenkinsapi
Requires:       python-rosdistro >= 0.4.0
Requires:       PyYAML

%if 0%{?with_python3}
%package -n python3-ros_buildfarm
Summary:        Build farm used to build the ROS ecosystem's packages
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
Requires:       python3-catkin_pkg >= 0.2.6
Requires:       python3-empy
Requires:       python3-jenkinsapi
Requires:       python3-rosdistro >= 0.4.0
Requires:       python3-PyYAML
%endif

%description
This package contains the scripts and templates to generate Jenkins jobs or
alternatively shell scripts to run jobs locally. Please look in the doc folder
for more information about how to invoke the job generation and an explanation
of the different job types.

The ROS build farm is using Docker for each step in the process. It is based on
the ROS distro specification REP 143 and uses a separate repository to configure
the jobs being generated (e.g.
https://github.com/ros-infrastructure/ros_buildfarm_config).

If you are going to use any of the provided infrastructure please consider
signing up for the build farm mailing list
(https://groups.google.com/d/forum/ros-sig-buildfarm) in order to receive
notifications e.g. about any upcoming changes.

%if 0%{?with_python3}
%description -n python3-ros_buildfarm
This package contains the scripts and templates to generate Jenkins jobs or
alternatively shell scripts to run jobs locally. Please look in the doc folder
for more information about how to invoke the job generation and an explanation
of the different job types.

The ROS build farm is using Docker for each step in the process. It is based on
the ROS distro specification REP 143 and uses a separate repository to configure
the jobs being generated (e.g.
https://github.com/ros-infrastructure/ros_buildfarm_config).

If you are going to use any of the provided infrastructure please consider
signing up for the build farm mailing list
(https://groups.google.com/d/forum/ros-sig-buildfarm) in order to receive
notifications e.g. about any upcoming changes.
%endif

%prep
%setup -qn ros_buildfarm-%{commit}
%patch0 -p1

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
find %{py3dir} -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python3}|'
%endif

find -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python2}|'

%build
%{__python2} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
rm -f build/scripts-%{python3_version}/*
popd
%endif

%install
%{__python2} setup.py install --skip-build --root %{buildroot}

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root %{buildroot}
popd
%endif

%files
%doc CONTRIBUTING.md LICENSE README.md
%{_bindir}/*
%{python2_sitelib}/ros_buildfarm
%{python2_sitelib}/ros_buildfarm-%{version}-py?.?.egg-info

%files -n python3-ros_buildfarm
%doc CONTRIBUTING.md LICENSE README.md
%{python3_sitelib}/ros_buildfarm
%{python3_sitelib}/ros_buildfarm-%{version}-py?.?.egg-info

%changelog
* Sun Feb 01 2015 Scott K Logan <logans@cottsay.net> - 0.1.2-4
- Add upstream patch to fix post_url exception

* Sun Feb 01 2015 Scott K Logan <logans@cottsay.net> - 0.1.2-3
- Fix shebang fix

* Sun Feb 01 2015 Scott K Logan <logans@cottsay.net> - 0.1.2-2
- Add python3 package
- Fix shebang in python2 scripts
- Add Requires: python-jenkinsapi

* Sat Jan 31 2015 Scott K Logan <logans@cottsay.net> - 0.1.2-1
- Initial package
